import asyncio
from typing import Hashable

from v6d2ctx.context import *

__all__ = ('lock_for', 'Locks',)


class Locks:
    def __init__(self) -> None:
        self.locks: dict[Hashable, asyncio.Lock] = {}

    def lock_for(self, key: Hashable, error_message: str) -> asyncio.Lock:
        if key is None:
            raise Explicit(error_message)
        if key in self.locks:
            return self.locks[key]
        else:
            return self.locks.setdefault(key, asyncio.Lock())


locks = Locks()
lock_for = locks.lock_for
